package routing;

import core.Settings;
import routing.util.*;

public class BasicEnergySeekerRouter extends BasicEnergyRouter implements
        MobilityEnergyDepletion, EnergySeeker {
    private VehicleBattery battery = new VehicleBattery();
    public BasicEnergySeekerRouter(Settings s) {
        super(s);
        this.state = State.SEEK;
    }
    public BasicEnergySeekerRouter(BasicEnergySeekerRouter prototype) {
        super(prototype);
        this.state = prototype.state;
    }
    @Override
    public MessageRouter replicate() {
        BasicEnergySeekerRouter prototype = this;
        return new BasicEnergySeekerRouter(prototype);
    }
    @Override
    public boolean isBelowThreshold() {
        return this.battery.getRemainingCapacity() <= 40;
    }
    @Override
    public EnergyModule getEnergyModule() {
        return this.battery;
    }
    @Override
    public void drainViaMovement(double distance) {
        this.battery.drainViaMovement(distance);
    }
    @Override
    protected void chargePeer(EnergySeeker seeker, double interval) {
    }
}
