package routing;

import core.Settings;
import routing.util.EnergyOasis;
import routing.util.EnergySeeker;
import routing.util.VehicleBattery;

import java.util.Comparator;
public class EnergyHomeRouter extends EnergyRouter {
    public EnergyHomeRouter(Settings settings) {
        super(settings);
        this.state = State.SUPPLY;
        this.energyModule = new EnergyOasis();
    }
    public EnergyHomeRouter(EnergyHomeRouter prototype) {
        super(prototype);
        this.state = prototype.state;
        this.energyModule = new EnergyOasis();
    }
    public MessageRouter replicate() {
        return new EnergyHomeRouter(this);
    }
    protected void updateState() {
    }
    protected Contact pickDesiredSupplier() {
        System.out.println("EnergyHomeRouter: picking a supplier, as a " +
                "supplier this should not occur");
        System.exit(1);
        return null;
    }
    @Override
    protected void orderSeekers() {
        this.seekers.sort(Comparator.comparingDouble(c -> c
                .connectionStartTime));

    }
    @Override
    protected void chargePeer(EnergySeeker seeker, double interval) {
        seeker.getEnergyModule().charge(VehicleBattery.CHARGE_SLOW, interval);
    }
}
