package routing;
import core.Settings;
import routing.util.EnergyOasis;
import routing.util.EnergySeeker;
import routing.util.EnergySupplier;
import routing.util.VehicleBattery;
import java.util.Comparator;
public class EnergyStationRouter extends EnergyRouter {
    public EnergyStationRouter(Settings settings) {
        super(settings);
        this.state = State.SUPPLY;
        this.energyModule = new EnergyOasis();
    }
    public EnergyStationRouter(EnergyStationRouter prototype) {
        super(prototype);
        this.state = prototype.state;
        this.energyModule = new EnergyOasis();
    }
    public MessageRouter replicate() {
        return new EnergyStationRouter(this);
    }
    protected void updateState() {
    }
    @Override
    protected Contact pickDesiredSupplier() {
        System.exit(1);
        return null;
    }
    @Override
    protected void orderSeekers() {
        this.seekers.sort(Comparator.comparingDouble(c -> c
                .connectionStartTime));
    }
    @Override
    protected void chargePeer(EnergySeeker seeker, double interval) {
        seeker.getEnergyModule().charge(VehicleBattery.CHARGE_FAST, interval);
    }
}
